---
displayed_sidebar: servicesSidebar
---

import ParameterTypes from "@site/src/components/ParameterTypes"

# IdempotencyKeyService

## constructor

### Parameters

<ParameterTypes parameters={[
  {
    "name": "__namedParameters",
    "type": "`InjectedDependencies`",
    "description": "",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  }
]} />

___

## Properties

<ParameterTypes parameters={[
  {
    "name": "__configModule__",
    "type": "`Record<string, unknown>`",
    "description": "",
    "optional": true,
    "defaultValue": "",
    "expandable": false,
    "children": []
  },
  {
    "name": "__container__",
    "type": "`any`",
    "description": "",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  },
  {
    "name": "__moduleDeclaration__",
    "type": "`Record<string, unknown>`",
    "description": "",
    "optional": true,
    "defaultValue": "",
    "expandable": false,
    "children": []
  },
  {
    "name": "idempotencyKeyRepository_",
    "type": "Repository&#60;[IdempotencyKey](../../entities/classes/entities.IdempotencyKey.mdx)&#62;",
    "description": "",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  },
  {
    "name": "manager_",
    "type": "`EntityManager`",
    "description": "",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  },
  {
    "name": "transactionManager_",
    "type": "`undefined` \\| `EntityManager`",
    "description": "",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  }
]} />

___

## Accessors

### activeManager\_

#### Returns

<ParameterTypes parameters={[
  {
    "name": "EntityManager",
    "type": "`EntityManager`",
    "optional": false,
    "defaultValue": "",
    "description": "",
    "expandable": false,
    "children": []
  }
]} />

___

## Methods

### atomicPhase\_

Wraps some work within a transactional block. If the service already has
a transaction manager attached this will be reused, otherwise a new
transaction manager is created.

#### Type Parameters

<ParameterTypes parameters={[
  {
    "name": "TResult",
    "type": "`object`",
    "description": "",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  },
  {
    "name": "TError",
    "type": "`object`",
    "description": "",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  }
]} />

#### Parameters

<ParameterTypes parameters={[
  {
    "name": "work",
    "type": "(`transactionManager`: `EntityManager`) => Promise&#60;TResult&#62;",
    "description": "the transactional work to be done",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  },
  {
    "name": "isolationOrErrorHandler",
    "type": "`IsolationLevel` \\| (`error`: `TError`) => Promise&#60;void \\| TResult&#62;",
    "description": "the isolation level to be used for the work.",
    "optional": true,
    "defaultValue": "",
    "expandable": false,
    "children": []
  },
  {
    "name": "maybeErrorHandlerOrDontFail",
    "type": "(`error`: `TError`) => Promise&#60;void \\| TResult&#62;",
    "description": "Potential error handler",
    "optional": true,
    "defaultValue": "",
    "expandable": false,
    "children": []
  }
]} />

#### Returns

<ParameterTypes parameters={[
  {
    "name": "Promise",
    "type": "Promise&#60;TResult&#62;",
    "optional": false,
    "defaultValue": "",
    "description": "the result of the transactional work",
    "expandable": false,
    "children": []
  }
]} />

___

### create

Creates an idempotency key for a request.
If no idempotency key is provided in request, we will create a unique
identifier.

#### Parameters

<ParameterTypes parameters={[
  {
    "name": "payload",
    "type": "`CreateIdempotencyKeyInput`",
    "description": "payload of request to create idempotency key for",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  }
]} />

#### Returns

<ParameterTypes parameters={[
  {
    "name": "Promise",
    "type": "Promise&#60;[IdempotencyKey](../../entities/classes/entities.IdempotencyKey.mdx)&#62;",
    "optional": false,
    "defaultValue": "",
    "description": "the created idempotency key",
    "expandable": false,
    "children": []
  }
]} />

___

### initializeRequest

Execute the initial steps in a idempotent request.

#### Parameters

<ParameterTypes parameters={[
  {
    "name": "headerKey",
    "type": "`string`",
    "description": "potential idempotency key from header",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  },
  {
    "name": "reqMethod",
    "type": "`string`",
    "description": "method of request",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  },
  {
    "name": "reqParams",
    "type": "`Record<string, unknown>`",
    "description": "params of request",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  },
  {
    "name": "reqPath",
    "type": "`string`",
    "description": "path of request",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  }
]} />

#### Returns

<ParameterTypes parameters={[
  {
    "name": "Promise",
    "type": "Promise&#60;[IdempotencyKey](../../entities/classes/entities.IdempotencyKey.mdx)&#62;",
    "optional": false,
    "defaultValue": "",
    "description": "the existing or created idempotency key",
    "expandable": false,
    "children": []
  }
]} />

___

### lock

Locks an idempotency.

#### Parameters

<ParameterTypes parameters={[
  {
    "name": "idempotencyKey",
    "type": "`string`",
    "description": "key to lock",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  }
]} />

#### Returns

<ParameterTypes parameters={[
  {
    "name": "Promise",
    "type": "Promise&#60;[IdempotencyKey](../../entities/classes/entities.IdempotencyKey.mdx)&#62;",
    "optional": false,
    "defaultValue": "",
    "description": "result of the update operation",
    "expandable": false,
    "children": []
  }
]} />

___

### retrieve

Retrieves an idempotency key

#### Parameters

<ParameterTypes parameters={[
  {
    "name": "idempotencyKeyOrSelector",
    "type": "`string` \\| [Selector](../../medusa/types/medusa.Selector.mdx)&#60;[IdempotencyKey](../../entities/classes/entities.IdempotencyKey.mdx)&#62;",
    "description": "key or selector to retrieve",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  }
]} />

#### Returns

<ParameterTypes parameters={[
  {
    "name": "Promise",
    "type": "Promise&#60;[IdempotencyKey](../../entities/classes/entities.IdempotencyKey.mdx)&#62;",
    "optional": false,
    "defaultValue": "",
    "description": "idempotency key",
    "expandable": false,
    "children": []
  }
]} />

___

### shouldRetryTransaction\_

#### Parameters

<ParameterTypes parameters={[
  {
    "name": "err",
    "type": "`Record<string, unknown>` \\| `object`",
    "description": "",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  }
]} />

#### Returns

<ParameterTypes parameters={[
  {
    "name": "boolean",
    "type": "`boolean`",
    "optional": true,
    "defaultValue": "",
    "description": "",
    "expandable": false,
    "children": []
  }
]} />

___

### update

Locks an idempotency.

#### Parameters

<ParameterTypes parameters={[
  {
    "name": "idempotencyKey",
    "type": "`string`",
    "description": "key to update",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  },
  {
    "name": "update",
    "type": "DeepPartial&#60;[IdempotencyKey](../../entities/classes/entities.IdempotencyKey.mdx)&#62;",
    "description": "update object",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  }
]} />

#### Returns

<ParameterTypes parameters={[
  {
    "name": "Promise",
    "type": "Promise&#60;[IdempotencyKey](../../entities/classes/entities.IdempotencyKey.mdx)&#62;",
    "optional": false,
    "defaultValue": "",
    "description": "result of the update operation",
    "expandable": false,
    "children": []
  }
]} />

___

### withTransaction

#### Parameters

<ParameterTypes parameters={[
  {
    "name": "transactionManager",
    "type": "`EntityManager`",
    "description": "",
    "optional": true,
    "defaultValue": "",
    "expandable": false,
    "children": []
  }
]} />

#### Returns

<ParameterTypes parameters={[
  {
    "name": "IdempotencyKeyService",
    "type": "`object`",
    "description": "",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  }
]} />

___

### workStage

Performs an atomic work stage.
An atomic work stage contains some related functionality, that needs to be
transactionally executed in isolation. An idempotent request will
always consist of 2 or more of these phases. The required phases are
"started" and "finished".

#### Parameters

<ParameterTypes parameters={[
  {
    "name": "idempotencyKey",
    "type": "`string`",
    "description": "current idempotency key",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  },
  {
    "name": "callback",
    "type": "(`transactionManager`: `EntityManager`) => Promise&#60;IdempotencyCallbackResult&#62;",
    "description": "functionality to execute within the phase",
    "optional": false,
    "defaultValue": "",
    "expandable": false,
    "children": []
  }
]} />

#### Returns

<ParameterTypes parameters={[
  {
    "name": "Promise",
    "type": "Promise&#60;[IdempotencyKey](../../entities/classes/entities.IdempotencyKey.mdx)&#62;",
    "optional": false,
    "defaultValue": "",
    "description": "new updated idempotency key",
    "expandable": false,
    "children": []
  }
]} />
